import gleam/dynamic/decode.{type Decoder}
import gleam/json.{type Json}

pub type TradeSymbol {
  PreciousStones
  QuartzSand
  SiliconCrystals
  AmmoniaIce
  LiquidHydrogen
  LiquidNitrogen
  IceWater
  ExoticMatter
  AdvancedCircuitry
  GravitonEmitters
  Iron
  IronOre
  Copper
  CopperOre
  Aluminum
  AluminumOre
  Silver
  SilverOre
  Gold
  GoldOre
  Platinum
  PlatinumOre
  Diamonds
  Uranite
  UraniteOre
  Meritium
  MeritiumOre
  Hydrocarbon
  Antimatter
  FabMats
  Fertilizers
  Fabrics
  Food
  Jewelry
  Machinery
  Firearms
  AssaultRifles
  MilitaryEquipment
  Explosives
  LabInstruments
  Ammunition
  Electronics
  ShipPlating
  ShipParts
  Equipment
  Fuel
  Medicine
  Drugs
  Clothing
  Microprocessors
  Plastics
  Polynucleotides
  Biocomposites
  QuantumStabilizers
  Nanobots
  AiMainframes
  QuantumDrives
  RoboticDrones
  CyberImplants
  GeneTherapeutics
  NeuralChips
  MoodRegulators
  ViralAgents
  MicroFusionGenerators
  Supergrains
  LaserRifles
  Holographics
  ShipSalvage
  RelicTech
  NovelLifeforms
  BotanicalSpecimens
  CulturalArtifacts
  FrameProbe
  FrameDrone
  FrameInterceptor
  FrameRacer
  FrameFighter
  FrameFrigate
  FrameShuttle
  FrameExplorer
  FrameMiner
  FrameLightFreighter
  FrameHeavyFreighter
  FrameTransport
  FrameDestroyer
  FrameCruiser
  FrameCarrier
  FrameBulkFreighter
  ReactorSolarI
  ReactorFusionI
  ReactorFissionI
  ReactorChemicalI
  ReactorAntimatterI
  EngineImpulseDriveI
  EngineIonDriveI
  EngineIonDriveII
  EngineHyperDriveI
  ModuleMineralProcessorI
  ModuleGasProcessorI
  ModuleCargoHoldI
  ModuleCargoHoldII
  ModuleCargoHoldIII
  ModuleCrewQuartersI
  ModuleEnvoyQuartersI
  ModulePassengerCabinI
  ModuleMicroRefineryI
  ModuleScienceLabI
  ModuleJumpDriveI
  ModuleJumpDriveII
  ModuleJumpDriveIII
  ModuleWarpDriveI
  ModuleWarpDriveII
  ModuleWarpDriveIII
  ModuleShieldGeneratorI
  ModuleShieldGeneratorII
  ModuleOreRefineryI
  ModuleFuelRefineryI
  MountGasSiphonI
  MountGasSiphonII
  MountGasSiphonIII
  MountSurveyorI
  MountSurveyorII
  MountSurveyorIII
  MountSensorArrayI
  MountSensorArrayII
  MountSensorArrayIII
  MountMiningLaserI
  MountMiningLaserII
  MountMiningLaserIII
  MountLaserCannonI
  MountMissileLauncherI
  MountTurretI
  ShipProbe
  ShipMiningDrone
  ShipSiphonDrone
  ShipInterceptor
  ShipLightHauler
  ShipCommandFrigate
  ShipExplorer
  ShipHeavyFreighter
  ShipLightShuttle
  ShipOreHound
  ShipRefiningFreighter
  ShipSurveyor
  ShipBulkFreighter
}

pub fn parse(value: String) -> Result(TradeSymbol, Nil) {
  case value {
    "PRECIOUS_STONES" -> Ok(PreciousStones)
    "QUARTZ_SAND" -> Ok(QuartzSand)
    "SILICON_CRYSTALS" -> Ok(SiliconCrystals)
    "AMMONIA_ICE" -> Ok(AmmoniaIce)
    "LIQUID_HYDROGEN" -> Ok(LiquidHydrogen)
    "LIQUID_NITROGEN" -> Ok(LiquidNitrogen)
    "ICE_WATER" -> Ok(IceWater)
    "EXOTIC_MATTER" -> Ok(ExoticMatter)
    "ADVANCED_CIRCUITRY" -> Ok(AdvancedCircuitry)
    "GRAVITON_EMITTERS" -> Ok(GravitonEmitters)
    "IRON" -> Ok(Iron)
    "IRON_ORE" -> Ok(IronOre)
    "COPPER" -> Ok(Copper)
    "COPPER_ORE" -> Ok(CopperOre)
    "ALUMINUM" -> Ok(Aluminum)
    "ALUMINUM_ORE" -> Ok(AluminumOre)
    "SILVER" -> Ok(Silver)
    "SILVER_ORE" -> Ok(SilverOre)
    "GOLD" -> Ok(Gold)
    "GOLD_ORE" -> Ok(GoldOre)
    "PLATINUM" -> Ok(Platinum)
    "PLATINUM_ORE" -> Ok(PlatinumOre)
    "DIAMONDS" -> Ok(Diamonds)
    "URANITE" -> Ok(Uranite)
    "URANITE_ORE" -> Ok(UraniteOre)
    "MERITIUM" -> Ok(Meritium)
    "MERITIUM_ORE" -> Ok(MeritiumOre)
    "HYDROCARBON" -> Ok(Hydrocarbon)
    "ANTIMATTER" -> Ok(Antimatter)
    "FAB_MATS" -> Ok(FabMats)
    "FERTILIZERS" -> Ok(Fertilizers)
    "FABRICS" -> Ok(Fabrics)
    "FOOD" -> Ok(Food)
    "JEWELRY" -> Ok(Jewelry)
    "MACHINERY" -> Ok(Machinery)
    "FIREARMS" -> Ok(Firearms)
    "ASSAULT_RIFLES" -> Ok(AssaultRifles)
    "MILITARY_EQUIPMENT" -> Ok(MilitaryEquipment)
    "EXPLOSIVES" -> Ok(Explosives)
    "LAB_INSTRUMENTS" -> Ok(LabInstruments)
    "AMMUNITION" -> Ok(Ammunition)
    "ELECTRONICS" -> Ok(Electronics)
    "SHIP_PLATING" -> Ok(ShipPlating)
    "SHIP_PARTS" -> Ok(ShipParts)
    "EQUIPMENT" -> Ok(Equipment)
    "FUEL" -> Ok(Fuel)
    "MEDICINE" -> Ok(Medicine)
    "DRUGS" -> Ok(Drugs)
    "CLOTHING" -> Ok(Clothing)
    "MICROPROCESSORS" -> Ok(Microprocessors)
    "PLASTICS" -> Ok(Plastics)
    "POLYNUCLEOTIDES" -> Ok(Polynucleotides)
    "BIOCOMPOSITES" -> Ok(Biocomposites)
    "QUANTUM_STABILIZERS" -> Ok(QuantumStabilizers)
    "NANOBOTS" -> Ok(Nanobots)
    "AI_MAINFRAMES" -> Ok(AiMainframes)
    "QUANTUM_DRIVES" -> Ok(QuantumDrives)
    "ROBOTIC_DRONES" -> Ok(RoboticDrones)
    "CYBER_IMPLANTS" -> Ok(CyberImplants)
    "GENE_THERAPEUTICS" -> Ok(GeneTherapeutics)
    "NEURAL_CHIPS" -> Ok(NeuralChips)
    "MOOD_REGULATORS" -> Ok(MoodRegulators)
    "VIRAL_AGENTS" -> Ok(ViralAgents)
    "MICRO_FUSION_GENERATORS" -> Ok(MicroFusionGenerators)
    "SUPERGRAINS" -> Ok(Supergrains)
    "LASER_RIFLES" -> Ok(LaserRifles)
    "HOLOGRAPHICS" -> Ok(Holographics)
    "SHIP_SALVAGE" -> Ok(ShipSalvage)
    "RELIC_TECH" -> Ok(RelicTech)
    "NOVEL_LIFEFORMS" -> Ok(NovelLifeforms)
    "BOTANICAL_SPECIMENS" -> Ok(BotanicalSpecimens)
    "CULTURAL_ARTIFACTS" -> Ok(CulturalArtifacts)
    "FRAME_PROBE" -> Ok(FrameProbe)
    "FRAME_DRONE" -> Ok(FrameDrone)
    "FRAME_INTERCEPTOR" -> Ok(FrameInterceptor)
    "FRAME_RACER" -> Ok(FrameRacer)
    "FRAME_FIGHTER" -> Ok(FrameFighter)
    "FRAME_FRIGATE" -> Ok(FrameFrigate)
    "FRAME_SHUTTLE" -> Ok(FrameShuttle)
    "FRAME_EXPLORER" -> Ok(FrameExplorer)
    "FRAME_MINER" -> Ok(FrameMiner)
    "FRAME_LIGHT_FREIGHTER" -> Ok(FrameLightFreighter)
    "FRAME_HEAVY_FREIGHTER" -> Ok(FrameHeavyFreighter)
    "FRAME_TRANSPORT" -> Ok(FrameTransport)
    "FRAME_DESTROYER" -> Ok(FrameDestroyer)
    "FRAME_CRUISER" -> Ok(FrameCruiser)
    "FRAME_CARRIER" -> Ok(FrameCarrier)
    "FRAME_BULK_FREIGHTER" -> Ok(FrameBulkFreighter)
    "REACTOR_SOLAR_I" -> Ok(ReactorSolarI)
    "REACTOR_FUSION_I" -> Ok(ReactorFusionI)
    "REACTOR_FISSION_I" -> Ok(ReactorFissionI)
    "REACTOR_CHEMICAL_I" -> Ok(ReactorChemicalI)
    "REACTOR_ANTIMATTER_I" -> Ok(ReactorAntimatterI)
    "ENGINE_IMPULSE_DRIVE_I" -> Ok(EngineImpulseDriveI)
    "ENGINE_ION_DRIVE_I" -> Ok(EngineIonDriveI)
    "ENGINE_ION_DRIVE_II" -> Ok(EngineIonDriveII)
    "ENGINE_HYPER_DRIVE_I" -> Ok(EngineHyperDriveI)
    "MODULE_MINERAL_PROCESSOR_I" -> Ok(ModuleMineralProcessorI)
    "MODULE_GAS_PROCESSOR_I" -> Ok(ModuleGasProcessorI)
    "MODULE_CARGO_HOLD_I" -> Ok(ModuleCargoHoldI)
    "MODULE_CARGO_HOLD_II" -> Ok(ModuleCargoHoldII)
    "MODULE_CARGO_HOLD_III" -> Ok(ModuleCargoHoldIII)
    "MODULE_CREW_QUARTERS_I" -> Ok(ModuleCrewQuartersI)
    "MODULE_ENVOY_QUARTERS_I" -> Ok(ModuleEnvoyQuartersI)
    "MODULE_PASSENGER_CABIN_I" -> Ok(ModulePassengerCabinI)
    "MODULE_MICRO_REFINERY_I" -> Ok(ModuleMicroRefineryI)
    "MODULE_SCIENCE_LAB_I" -> Ok(ModuleScienceLabI)
    "MODULE_JUMP_DRIVE_I" -> Ok(ModuleJumpDriveI)
    "MODULE_JUMP_DRIVE_II" -> Ok(ModuleJumpDriveII)
    "MODULE_JUMP_DRIVE_III" -> Ok(ModuleJumpDriveIII)
    "MODULE_WARP_DRIVE_I" -> Ok(ModuleWarpDriveI)
    "MODULE_WARP_DRIVE_II" -> Ok(ModuleWarpDriveII)
    "MODULE_WARP_DRIVE_III" -> Ok(ModuleWarpDriveIII)
    "MODULE_SHIELD_GENERATOR_I" -> Ok(ModuleShieldGeneratorI)
    "MODULE_SHIELD_GENERATOR_II" -> Ok(ModuleShieldGeneratorII)
    "MODULE_ORE_REFINERY_I" -> Ok(ModuleOreRefineryI)
    "MODULE_FUEL_REFINERY_I" -> Ok(ModuleFuelRefineryI)
    "MOUNT_GAS_SIPHON_I" -> Ok(MountGasSiphonI)
    "MOUNT_GAS_SIPHON_II" -> Ok(MountGasSiphonII)
    "MOUNT_GAS_SIPHON_III" -> Ok(MountGasSiphonIII)
    "MOUNT_SURVEYOR_I" -> Ok(MountSurveyorI)
    "MOUNT_SURVEYOR_II" -> Ok(MountSurveyorII)
    "MOUNT_SURVEYOR_III" -> Ok(MountSurveyorIII)
    "MOUNT_SENSOR_ARRAY_I" -> Ok(MountSensorArrayI)
    "MOUNT_SENSOR_ARRAY_II" -> Ok(MountSensorArrayII)
    "MOUNT_SENSOR_ARRAY_III" -> Ok(MountSensorArrayIII)
    "MOUNT_MINING_LASER_I" -> Ok(MountMiningLaserI)
    "MOUNT_MINING_LASER_II" -> Ok(MountMiningLaserII)
    "MOUNT_MINING_LASER_III" -> Ok(MountMiningLaserIII)
    "MOUNT_LASER_CANNON_I" -> Ok(MountLaserCannonI)
    "MOUNT_MISSILE_LAUNCHER_I" -> Ok(MountMissileLauncherI)
    "MOUNT_TURRET_I" -> Ok(MountTurretI)
    "SHIP_PROBE" -> Ok(ShipProbe)
    "SHIP_MINING_DRONE" -> Ok(ShipMiningDrone)
    "SHIP_SIPHON_DRONE" -> Ok(ShipSiphonDrone)
    "SHIP_INTERCEPTOR" -> Ok(ShipInterceptor)
    "SHIP_LIGHT_HAULER" -> Ok(ShipLightHauler)
    "SHIP_COMMAND_FRIGATE" -> Ok(ShipCommandFrigate)
    "SHIP_EXPLORER" -> Ok(ShipExplorer)
    "SHIP_HEAVY_FREIGHTER" -> Ok(ShipHeavyFreighter)
    "SHIP_LIGHT_SHUTTLE" -> Ok(ShipLightShuttle)
    "SHIP_ORE_HOUND" -> Ok(ShipOreHound)
    "SHIP_REFINING_FREIGHTER" -> Ok(ShipRefiningFreighter)
    "SHIP_SURVEYOR" -> Ok(ShipSurveyor)
    "SHIP_BULK_FREIGHTER" -> Ok(ShipBulkFreighter)
    _ -> Error(Nil)
  }
}

pub fn decoder() -> Decoder(TradeSymbol) {
  use value <- decode.then(decode.string)
  case parse(value) {
    Ok(trade_symbol) -> decode.success(trade_symbol)
    Error(Nil) -> decode.failure(PreciousStones, "TradeSymbol")
  }
}

pub fn to_string(trade_symbol: TradeSymbol) -> String {
  case trade_symbol {
    PreciousStones -> "PRECIOUS_STONES"
    QuartzSand -> "QUARTZ_SAND"
    SiliconCrystals -> "SILICON_CRYSTALS"
    AmmoniaIce -> "AMMONIA_ICE"
    LiquidHydrogen -> "LIQUID_HYDROGEN"
    LiquidNitrogen -> "LIQUID_NITROGEN"
    IceWater -> "ICE_WATER"
    ExoticMatter -> "EXOTIC_MATTER"
    AdvancedCircuitry -> "ADVANCED_CIRCUITRY"
    GravitonEmitters -> "GRAVITON_EMITTERS"
    Iron -> "IRON"
    IronOre -> "IRON_ORE"
    Copper -> "COPPER"
    CopperOre -> "COPPER_ORE"
    Aluminum -> "ALUMINUM"
    AluminumOre -> "ALUMINUM_ORE"
    Silver -> "SILVER"
    SilverOre -> "SILVER_ORE"
    Gold -> "GOLD"
    GoldOre -> "GOLD_ORE"
    Platinum -> "PLATINUM"
    PlatinumOre -> "PLATINUM_ORE"
    Diamonds -> "DIAMONDS"
    Uranite -> "URANITE"
    UraniteOre -> "URANITE_ORE"
    Meritium -> "MERITIUM"
    MeritiumOre -> "MERITIUM_ORE"
    Hydrocarbon -> "HYDROCARBON"
    Antimatter -> "ANTIMATTER"
    FabMats -> "FAB_MATS"
    Fertilizers -> "FERTILIZERS"
    Fabrics -> "FABRICS"
    Food -> "FOOD"
    Jewelry -> "JEWELRY"
    Machinery -> "MACHINERY"
    Firearms -> "FIREARMS"
    AssaultRifles -> "ASSAULT_RIFLES"
    MilitaryEquipment -> "MILITARY_EQUIPMENT"
    Explosives -> "EXPLOSIVES"
    LabInstruments -> "LAB_INSTRUMENTS"
    Ammunition -> "AMMUNITION"
    Electronics -> "ELECTRONICS"
    ShipPlating -> "SHIP_PLATING"
    ShipParts -> "SHIP_PARTS"
    Equipment -> "EQUIPMENT"
    Fuel -> "FUEL"
    Medicine -> "MEDICINE"
    Drugs -> "DRUGS"
    Clothing -> "CLOTHING"
    Microprocessors -> "MICROPROCESSORS"
    Plastics -> "PLASTICS"
    Polynucleotides -> "POLYNUCLEOTIDES"
    Biocomposites -> "BIOCOMPOSITES"
    QuantumStabilizers -> "QUANTUM_STABILIZERS"
    Nanobots -> "NANOBOTS"
    AiMainframes -> "AI_MAINFRAMES"
    QuantumDrives -> "QUANTUM_DRIVES"
    RoboticDrones -> "ROBOTIC_DRONES"
    CyberImplants -> "CYBER_IMPLANTS"
    GeneTherapeutics -> "GENE_THERAPEUTICS"
    NeuralChips -> "NEURAL_CHIPS"
    MoodRegulators -> "MOOD_REGULATORS"
    ViralAgents -> "VIRAL_AGENTS"
    MicroFusionGenerators -> "MICRO_FUSION_GENERATORS"
    Supergrains -> "SUPERGRAINS"
    LaserRifles -> "LASER_RIFLES"
    Holographics -> "HOLOGRAPHICS"
    ShipSalvage -> "SHIP_SALVAGE"
    RelicTech -> "RELIC_TECH"
    NovelLifeforms -> "NOVEL_LIFEFORMS"
    BotanicalSpecimens -> "BOTANICAL_SPECIMENS"
    CulturalArtifacts -> "CULTURAL_ARTIFACTS"
    FrameProbe -> "FRAME_PROBE"
    FrameDrone -> "FRAME_DRONE"
    FrameInterceptor -> "FRAME_INTERCEPTOR"
    FrameRacer -> "FRAME_RACER"
    FrameFighter -> "FRAME_FIGHTER"
    FrameFrigate -> "FRAME_FRIGATE"
    FrameShuttle -> "FRAME_SHUTTLE"
    FrameExplorer -> "FRAME_EXPLORER"
    FrameMiner -> "FRAME_MINER"
    FrameLightFreighter -> "FRAME_LIGHT_FREIGHTER"
    FrameHeavyFreighter -> "FRAME_HEAVY_FREIGHTER"
    FrameTransport -> "FRAME_TRANSPORT"
    FrameDestroyer -> "FRAME_DESTROYER"
    FrameCruiser -> "FRAME_CRUISER"
    FrameCarrier -> "FRAME_CARRIER"
    FrameBulkFreighter -> "FRAME_BULK_FREIGHTER"
    ReactorSolarI -> "REACTOR_SOLAR_I"
    ReactorFusionI -> "REACTOR_FUSION_I"
    ReactorFissionI -> "REACTOR_FISSION_I"
    ReactorChemicalI -> "REACTOR_CHEMICAL_I"
    ReactorAntimatterI -> "REACTOR_ANTIMATTER_I"
    EngineImpulseDriveI -> "ENGINE_IMPULSE_DRIVE_I"
    EngineIonDriveI -> "ENGINE_ION_DRIVE_I"
    EngineIonDriveII -> "ENGINE_ION_DRIVE_II"
    EngineHyperDriveI -> "ENGINE_HYPER_DRIVE_I"
    ModuleMineralProcessorI -> "MODULE_MINERAL_PROCESSOR_I"
    ModuleGasProcessorI -> "MODULE_GAS_PROCESSOR_I"
    ModuleCargoHoldI -> "MODULE_CARGO_HOLD_I"
    ModuleCargoHoldII -> "MODULE_CARGO_HOLD_II"
    ModuleCargoHoldIII -> "MODULE_CARGO_HOLD_III"
    ModuleCrewQuartersI -> "MODULE_CREW_QUARTERS_I"
    ModuleEnvoyQuartersI -> "MODULE_ENVOY_QUARTERS_I"
    ModulePassengerCabinI -> "MODULE_PASSENGER_CABIN_I"
    ModuleMicroRefineryI -> "MODULE_MICRO_REFINERY_I"
    ModuleScienceLabI -> "MODULE_SCIENCE_LAB_I"
    ModuleJumpDriveI -> "MODULE_JUMP_DRIVE_I"
    ModuleJumpDriveII -> "MODULE_JUMP_DRIVE_II"
    ModuleJumpDriveIII -> "MODULE_JUMP_DRIVE_III"
    ModuleWarpDriveI -> "MODULE_WARP_DRIVE_I"
    ModuleWarpDriveII -> "MODULE_WARP_DRIVE_II"
    ModuleWarpDriveIII -> "MODULE_WARP_DRIVE_III"
    ModuleShieldGeneratorI -> "MODULE_SHIELD_GENERATOR_I"
    ModuleShieldGeneratorII -> "MODULE_SHIELD_GENERATOR_II"
    ModuleOreRefineryI -> "MODULE_ORE_REFINERY_I"
    ModuleFuelRefineryI -> "MODULE_FUEL_REFINERY_I"
    MountGasSiphonI -> "MOUNT_GAS_SIPHON_I"
    MountGasSiphonII -> "MOUNT_GAS_SIPHON_II"
    MountGasSiphonIII -> "MOUNT_GAS_SIPHON_III"
    MountSurveyorI -> "MOUNT_SURVEYOR_I"
    MountSurveyorII -> "MOUNT_SURVEYOR_II"
    MountSurveyorIII -> "MOUNT_SURVEYOR_III"
    MountSensorArrayI -> "MOUNT_SENSOR_ARRAY_I"
    MountSensorArrayII -> "MOUNT_SENSOR_ARRAY_II"
    MountSensorArrayIII -> "MOUNT_SENSOR_ARRAY_III"
    MountMiningLaserI -> "MOUNT_MINING_LASER_I"
    MountMiningLaserII -> "MOUNT_MINING_LASER_II"
    MountMiningLaserIII -> "MOUNT_MINING_LASER_III"
    MountLaserCannonI -> "MOUNT_LASER_CANNON_I"
    MountMissileLauncherI -> "MOUNT_MISSILE_LAUNCHER_I"
    MountTurretI -> "MOUNT_TURRET_I"
    ShipProbe -> "SHIP_PROBE"
    ShipMiningDrone -> "SHIP_MINING_DRONE"
    ShipSiphonDrone -> "SHIP_SIPHON_DRONE"
    ShipInterceptor -> "SHIP_INTERCEPTOR"
    ShipLightHauler -> "SHIP_LIGHT_HAULER"
    ShipCommandFrigate -> "SHIP_COMMAND_FRIGATE"
    ShipExplorer -> "SHIP_EXPLORER"
    ShipHeavyFreighter -> "SHIP_HEAVY_FREIGHTER"
    ShipLightShuttle -> "SHIP_LIGHT_SHUTTLE"
    ShipOreHound -> "SHIP_ORE_HOUND"
    ShipRefiningFreighter -> "SHIP_REFINING_FREIGHTER"
    ShipSurveyor -> "SHIP_SURVEYOR"
    ShipBulkFreighter -> "SHIP_BULK_FREIGHTER"
  }
}

pub fn encode(trade_symbol: TradeSymbol) -> Json {
  json.string(to_string(trade_symbol))
}
